-- -----------------------------------------------------------------
-- File: AIOB.lua
--
-- Purpose: Functions for AIOB WoW Window.
--
-- Author: Ramble
--
-- Credits:
--   Starven, for MyInventory
--   Kaitlin, for BankItems
--   Sarf, for the original concept of AllInOneInventory
-- -----------------------------------------------------------------

function AIOB_Split(toCut, separator)
   if toCut == nil or separator == nil then
      return nil
   end
   local splitted = {};
   local i = 0;
   local regEx = "([^" .. separator .. "]*)" .. separator .. "?";

   for item in string.gmatch(toCut .. separator, regEx) do
      i = i + 1;
      splitted[i] = AIOI_Trim(item) or '';
   end
   splitted[i] = nil;
   return splitted;
end

function AIOB_GetBankSlotCost(bags)
   if bags == 0 then
      return 1000;
   elseif bags == 1 then
      return 10000;
   elseif bags == 2 then
      return 100000;
   elseif bags == 3 then
      return 250000;
   elseif bags == 4 then
      return 500000;
   elseif bags == 5 then
      return 1000000;
   else
      return 0;
   end
end
