local bankPlayer = nil;
local PlayerName = nil;

function AIOB_setPlayerName(player)
   PlayerName = player
end

function AIOB_getPlayerName()
   return PlayerName
end

function AIOB_setBankPlayer(player)
   bankPlayer = player;
end

function AIOB_getBankPlayer()
   return bankPlayer;
end

function AIOIFrame_OnMouseDown(arg1)
   if ( arg1 == "LeftButton" ) then
      if ( AIOILock == 0 ) then
         -- this:StartMoving();
         AIOIAnchorFrame:StartMoving();
      else
         AIOI_Print("AIOI is locked and can not move...");
      end
   end
end

function AIOIFrame_OnMouseUp(arg1)
   if ( arg1 == "LeftButton" ) then
      this:StopMovingOrSizing();
      AIOIAnchorFrame:StopMovingOrSizing();
   end
end


-- Item Button Events {{{
function AIOIFrameItemButton_OnLoad()
   this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
   this:RegisterForDrag("LeftButton");
   this:RegisterEvent("CURSOR_UPDATE");
   this:RegisterEvent("BAG_UPDATE_COOLDOWN");

   this.SplitStack = function(button, split)
      SplitContainerItem(button:GetParent():GetID(), button:GetID(), split);
   end
end


local hookedTradeFrame = false

function TFShow()
  if hookedTradeFrame and not CursorHasItem() and UnitName("target") == hookedTradeFrame then
    ClickTradeButton(1)
  end
  hookedTradeFrame = false
end

hooksecurefunc("TradeFrame_OnShow", TFShow)

-- DressingRoom code here
function AIOIFrameItemButton_OnClick(button, ignoreShift)
   local bag, slot = this.bagIndex, this.itemIndex;
   local link = GetContainerItemLink(bag,slot)

   if ( button == "LeftButton" ) then
      if ( IsShiftKeyDown() and not ignoreShift ) then
         if ( ChatFrameEditBox:IsVisible() ) then
            ChatFrameEditBox:Insert(link);
         else
            local texture, itemCount, locked = GetContainerItemInfo(bag, slot);
            if ( not locked ) then
               this.SplitStack = function(button, split)
                  SplitContainerItem(bag, slot, split);
               end
               OpenStackSplitFrame(this.count, this, "BOTTOMRIGHT", "TOPRIGHT");
            end
         end
      elseif ( IsControlKeyDown() ) then
         DressUpItemLink(link);
      else
         PickupContainerItem(bag, slot);

         -- auto add to mail frame, trade, and auction (if alt key is down)
         if SendMailFrame:IsVisible() and not IsAddOnLoaded("Postal") and not IsAddOnLoaded("BulkMail2") then
            ClickSendMailItemButton()

          elseif TradeFrame:IsVisible() then
            for i = 1, 6 do
               if not GetTradePlayerItemLink(i) then
                  ClickTradeButton(i)
                  return
               end
            end

         --Shamino added on behalf of Grennon.  Adds support for posting item into Auctioneer AuctionPost frame, when its available.
         elseif AuctionFrameTabPost and AuctionFrameTabPost:IsVisible() and IsAddOnLoaded("Auctioneer") then
            AuctionFrameTabPost:Click()
            AuctionFramePost_AuctionItem_OnClick(AuctionFramePostAuctionItem)

         elseif AuctionFrameAuctions and AuctionFrameAuctions:IsVisible() and not IsAddOnLoaded("Fence") then
            ClickAuctionSellItemButton()

         elseif not CursorHasItem() and UnitExists("target") and CheckInteractDistance("target", 2)
            and UnitIsFriend("player", "target") and UnitIsPlayer("target")  then
            InitiateTrade("target")
            hookedTradeFrame = true
          end
      end
   elseif ( button == "RightButton" ) then
      if ( IsShiftKeyDown() and MerchantFrame:IsVisible() and not ignoreShift ) then
         this.SplitStack = function(button, split)
            SplitContainerItem(button:GetParent():GetID(), button:GetID(), split);
            MerchantItemButton_OnClick("LeftButton");
         end
         OpenStackSplitFrame(this.count, this, "BOTTOMRIGHT", "TOPRIGHT");
      elseif ( MerchantFrame:IsVisible() and MerchantFrame.selectedTab == 2 ) then
         -- Don't sell the item if the buyback tab is selected
         return;
      else
         UseContainerItem(bag, slot);
         StackSplitFrame:Hide();
      end
   end
end

function AIOIFrameItemButton_OnEnter()
   local bag, slot = this.bagIndex, this.itemIndex;
   this:GetParent():SetID(this.bagIndex);
   this:SetID(this.itemIndex);
   ContainerFrameItemButton_OnEnter()
   AIOI_HighlightItemBag(bag);

   if true then
      return
   end

   --  Mimiking: ContainerFrameItemButton_OnEnter() - BEGIN
   GameTooltip:SetOwner(this, "ANCHOR_LEFT");
   local hasCooldown, repairCost = GameTooltip:SetBagItem(bag, slot);
   if ( hasCooldown ) then
      this.updateTooltip = TOOLTIP_UPDATE_TIME;
   else
      this.updateTooltip = nil;
   end
   if ( InRepairMode() and (repairCost and repairCost > 0) ) then
      GameTooltip:AddLine(TEXT(REPAIR_COST), "", 1, 1, 1);
      SetTooltipMoney(GameTooltip, repairCost);
      GameTooltip:Show();
   elseif ( MerchantFrame:IsVisible() ) then
      ShowContainerSellCursor(bag, slot);
   elseif ( this.readable ) then
      ShowInspectCursor();
   end
   --  Mimiking: ContainerFrameItemButton_OnEnter() - END

end

function AIOIFrameItemButton_OnLeave()
   AIOI_HighlightItemBag(this.bagIndex, 1);
   this.updateTooltip = nil;
   GameTooltip:Hide();
   ResetCursor();
end

function AIOIFrameItemButton_OnUpdate(elapsed)
   if ( not this.updateTooltip ) then
      return;
   end

   this.updateTooltip = this.updateTooltip - elapsed;
   if ( this.updateTooltip > 0 ) then
      return;
   end

   if ( GameTooltip:IsOwned(this) ) then
      AIOIFrameItemButton_OnEnter();
   else
      this.updateTooltip = nil;
   end
end
-- }}}

-- Bag Button Events {{{
function AIOI_Backpack_OnEnter()
   GameTooltip:SetOwner(this,"ANCHOR_LEFT");
   GameTooltip:SetText(TEXT(BACKPACK_TOOLTIP),1.0,1.0,1.0);
   local keyBinding = GetBindingKey("TOGGLEBACKPACK");
   if ( keyBinding ) then
     GameTooltip:AppendText(" "..NORMAL_FONT_COLOR_CODE.."("..keyBinding..")"..FONT_COLOR_CODE_CLOSE);
   end
   AIOI_HighlightBagItems(0);
end

function AIOI_Backpack_OnLeave()
   GameTooltip:Hide();
   AIOI_HighlightBagItems(0,1);
end

function AIOI_BagButton_OnEnter()
   GameTooltip:SetOwner(this,"ANCHOR_RIGHT");
   local hasCooldown, repairCost = GameTooltip:SetInventoryItem("player", this:GetID());
   AIOI_HighlightBagItems(1+this:GetID()- AIOI_____Bag0Slot:GetID());
end

function AIOI_BagButton_OnLeave()
   this.updateTooltip = nil;
   GameTooltip:Hide();
   ResetCursor();
   local bagID = 1+this:GetID()-AIOI_____Bag0Slot:GetID();
   AIOI_HighlightBagItems(bagID, 1);
end

function AIOI_BagButton_OnClick()
   local index = tonumber(strsub(this:GetName(), 13, 13))+2;
   local val = strsub(AIOIBags, index, index);
   if not PutItemInBag(this:GetID()) then
      local bagID = 1+this:GetID()-AIOI_____Bag0Slot:GetID();
      AIOI_HighlightBagItems(bagID, 1);
      if val == "1" then
         val = "0"
      else
         val = "1"
      end
      AIOIBags = strsub(AIOIBags, 1, index-1)..val..strsub(AIOIBags, index+1);
      AIOI_Toggle_Option("Bags", AIOIBags);
      AIOI_UpdateBagState();
      AIOIFrame_UpdateLook();
      AIOIFrame_Update();
   end
end
function AIOI_Backpack_OnClick()
   local val = strsub(AIOIBags, 1, 1);
   if not PutItemInBackpack() then
      AIOI_HighlightBagItems(0,1);
      if val == "1" then
         val = "0"
      else
         val = "1"
      end
      AIOIBags = val..strsub(AIOIBags, 2);
      AIOI_UpdateBagState();
      AIOIFrame_UpdateLook();
      AIOIFrame_Update();
      AIOI_Toggle_Option("Bags", AIOIBags);
   end
end
function AIOI_BagButton_OnDragStart()
   --BagSlotButton_OnDrag();
   PickupBagFromSlot(this:GetID());
   PlaySound("BAGMENUBUTTONPRESS");
end
function AIOI_BagButton_OnReceiveDrag()
   PutItemInBag(this:GetID());
end
-- }}}

function AIOBFrame_Button_OnEnter()
   --show tooltip
   local bagName = strsub(this:GetName(), 10, 15);  -- 14 instead of 13, so bags > 9 will work.
   local curBag;
   local cooldownInfo;

   GameTooltip:SetOwner(this,"ANCHOR_RIGHT");

   if AIOB_GetAtBank() then
      local hasCooldown, repairCost;

      if (this.isBag) then
         AIOB_HighlightBag(this:GetID(), bagName);
         local inventoryID = BankButtonIDToInvSlotID(this:GetID(), 1);
         GameTooltip:SetInventoryItem("player", inventoryID);

      else
         AIOB_HighlightBag(this.bagIndex, bagName, 1);
         if this.bagIndex < 0 then
            local newIndex = BankFrameItem1:GetInventorySlot();
            GameTooltip:SetInventoryItem("player", 39+this.itemIndex);
         else
            GameTooltip:SetBagItem(this.bagIndex, this.itemIndex);
         end
      end

   else
      if LootLink_AutoInfoOff then
         LootLink_AutoInfoOff();
      end
      if (this.isBag) then
         local item = AIOB_getBankPlayer()[bagName]
         local myHyperlink = AIOB_GetHyperlink(item);
         if myHyperlink then
            local inventoryID = BankButtonIDToInvSlotID(this:GetID(), 1);

            GameTooltip:SetHyperlink(myHyperlink);
            if AIOI_GetItemSoulBound(item) then
               GameTooltipTextLeft2:SetText(ITEM_SOULBOUND);
            end
            if AIOI_GetItemMadeBy(item) then
               GameTooltip:AddLine(format(ITEM_CREATED_BY, AIOI_GetItemMadeBy(item)));
            end
            GameTooltip:Show();
         end
         AIOB_HighlightBag(this:GetID(), bagName);

      -- if we are not a bag
      else
         AIOB_HighlightBag(this.bagIndex, bagName, 1);
         -- note("ONENTER: ", this.bagIndex, bagName)
         curBag = AIOB_GetBag(this.bagIndex);
         if curBag then
            local item = curBag[this.itemIndex]
            local myHyperlink
            myHyperlink = AIOB_GetHyperlink(item);
            -- note('ITEM', item, myHyperlink)
            if myHyperlink then
               local inventoryID = BankButtonIDToInvSlotID(this:GetID(), 1);
               -- note("ARG", curBag, item)
               GameTooltip:SetHyperlink(myHyperlink);
               if AIOI_GetItemSoulBound(item) then
                  GameTooltipTextLeft2:SetText(ITEM_SOULBOUND);
               end
               if AIOI_GetItemMadeBy(item) then
                  GameTooltip:AddLine(format(ITEM_CREATED_BY, AIOI_GetItemMadeBy(item)));
               end
               local cooldownInfo = AIOB_GetCooldown(item);
               if cooldownInfo and AIOI_GetCoolDownEnabled(item) and AIOI_GetCoolDownEnabled(item) > 0 and AIOI_GetCoolDownDuration(item) > 0 then
                  CoolDownString = AIOB_GetCooldownString(cooldownInfo);
                  GameTooltip:AddLine(CoolDownString, 1.0, 1.0, 1.0);
               end
               GameTooltip:Show();
            end

-- TRYING TO GET AUCTIONEER TOOLTIPS TO SHOW.
            -- SetItemRef(AIOB_GetLink(item), AIOI_GetItemName(item), "LeftButton")

            -- HideUIPanel(ItemRefTooltip);
            -- ShowUIPanel(ItemRefTooltip);
            -- if ( not ItemRefTooltip:IsShown() ) then
               -- ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");
            -- end
            -- ItemRefTooltip:SetHyperlink(myHyperlink);

            -- Auctioneer.Tooltip.HookTooltip(nil, nil, GameTooltip, AIOI_GetItemName(item), AIOB_GetLink(item), AIOB_GetItemQuality(item), AIOI_GetItemCount(item))
         end
      end
      if LootLink_AutoInfoOn then
         LootLink_AutoInfoOn();
      end
   end
end

function AIOBFrame_Button_OnLeave()
   if this.isBag then
      local bagName= strsub(this:GetName(), 10, 13);
      local i, found;
      for i=1, AIOB_MAX_ID do
         local itemButton = getglobal("AIOBFrameItem"..i);
         if itemButton.bagIndex == this:GetID() then
            found = true;
            itemButton:UnlockHighlight();
         else
            if found then
               break;
            end
         end
      end
   else
      if this.bagIndex > -1 then
         getglobal("AIOBFrameBag"..(this.bagIndex)):UnlockHighlight();
      end

   end
   GameTooltip:Hide();
end

function AIOBFrame_OnHide()
   if AIOB_GetAtBank() then
      CloseBankFrame();
   end
   PlaySound("igBackPackClose");
end

function AIOBFrame_OnShow()
   if AIOB_GetAtBank() then
      AIOBFramePurchaseButton:Enable();
   else
      AIOBFramePurchaseButton:Disable();
   end
   AIOB_UpdateTotalMoney();
   AIOBFrame_UpdateLookIfNeeded();
   PlaySound("igBackPackOpen");
end

function AIOBFrameItemButton_OnLoad()
   this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
   this:RegisterForDrag("LeftButton");

   this.SplitStack = function(button, split)
      SplitContainerItem(button:GetParent():GetID(), button:GetID(), split);
   end
end

function AIOBFrameItemButton_OnClick(button, ignoreShift)
   if AIOB_GetBag(this.bagIndex) == nil then
      return
   end

   local myLink;
   local item = AIOB_GetBag(this.bagIndex)[this.itemIndex];
   if (button == "LeftButton" ) then
      if (IsShiftKeyDown() and (not ignoreShift)) then
         if ChatFrameEditBox:IsVisible() or ( MacroFrameText and MacroFrameText:IsVisible() ) then
            -- Insert Link
            myLink = AIOB_GetLink(item);
            if myLink then
               if ChatFrameEditBox:IsVisible() then
                  ChatFrameEditBox:Insert(myLink);
               elseif ( MacroFrameText and MacroFrameText:IsVisible() ) then
                  MacroFrameText:Insert(myLink);
               end
            end
         else
            if AIOB_GetAtBank() then
               --Shift key down, left mouse button
               local texture, itemCount, locked = GetContainerItemInfo(this.bagIndex, this.itemIndex);
               if ( not locked ) then
                  this.SplitStack = function(button, split)
                     SplitContainerItem(button.bagIndex, button.itemIndex, split);
                  end
                  OpenStackSplitFrame(this.count, this, "BOTTOMRIGHT", "TOPRIGHT");
               end
            end
         end
      else
         -- no shift, left mouse button
         if AIOB_GetAtBank()==true then
            PickupContainerItem(this.bagIndex, this.itemIndex);
         end
      end
   elseif (button == "RightButton") then
      if AIOB_GetAtBank()==true then
         UseContainerItem(this.bagIndex, this.itemIndex);
      end
   end
end

function AIOBFrameItemButtonBag_OnShiftClick(button, ignoreShift)
   local bankBag = getglobal("BankFrameBag"..(tonumber(strsub(this:GetName(), 13, 15))-4));
   local inventoryID = BankButtonIDToInvSlotID(bankBag:GetID(), 1);
   if ( ChatFrameEditBox:IsVisible() ) then
      local bagName= strsub(this:GetName(), 12, 15);
      local myLink;
      myLink = AIOB_GetLink(AIOB_getBankPlayer()[bagName]);
      if myLink then
         if ChatFrameEditBox:IsVisible() then
            ChatFrameEditBox:Insert(myLink);
         elseif ( MacroFrameText and MacroFrameText:IsVisible() ) then
            MacroFrameText:Insert(myLink);
         end
      end
   else
       -- Shift key, no chat box
      if AIOB_GetAtBank() then
         PickupBagFromSlot(inventoryID);
         PlaySound("BAGMENUBUTTONPRESS");
      end
   end
end

function AIOBFrameItemButtonBag_OnClick(button, ignoreShift)
   local bankBag = getglobal("BankFrameBag"..(tonumber(strsub(this:GetName(), 13, 15))-4));
   local inventoryID = BankButtonIDToInvSlotID(bankBag:GetID(), 1);
   AIOI_DEBUG(bankBag:GetName().." "..inventoryID);
       -- No ShiftKey
   if AIOB_GetAtBank() then
      local hadItem = PutItemInBag(inventoryID);
      local id = this:GetID();
   end
end
