
-- Frame Events {{{
function AIOIFrame_OnEvent(event)
   if ( event == "VARIABLES_LOADED" ) then
      AIOI_Setup_Hooks(1);
      AIOI_DEBUG("Variables Loaded...");
      AIOI_Loaded = true;
      AIOI_MyAddonsRegister();
      AIOI_InitializeProfile();
      this:UnregisterEvent(event);
      this:RegisterEvent("PLAYER_ENTERING_WORLD")
      this:RegisterEvent("PLAYER_LEAVING_WORLD")
   end
   if not AIOI_Loaded then
      return
   end
   --if ( event == "UNIT_NAME_UPDATE" and arg1 == "player" and UnitName("player") ~= UNKNOWNOBJECT) then
      --AIOI_InitializeProfile();
   --end
   if AIOB_getPlayerName() == nil then
      return
   end

   if event == "PLAYER_LEAVING_WORLD" then
      this:UnregisterEvent("BAG_UPDATE");
      this:UnregisterEvent("BAG_UPDATE_COOLDOWN");
      this:UnregisterEvent("ITEM_LOCK_CHANGED");
      this:UnregisterEvent("UPDATE_INVENTORY_ALERTS");
   elseif event == "PLAYER_ENTERING_WORLD" then
      this:RegisterEvent("BAG_UPDATE");
      this:RegisterEvent("BAG_UPDATE_COOLDOWN");
      this:RegisterEvent("ITEM_LOCK_CHANGED");
      this:RegisterEvent("UPDATE_INVENTORY_ALERTS");
   elseif ( event == "BAG_UPDATE" ) then
      if ( this:IsVisible() ) then
         AIOI_DEBUG("BAG_UPDATE Event fired.");
         AIOIFrame_Update(AIOIFrame);
      end
   elseif ( event == "ITEM_LOCK_CHANGED" or event == "BAG_UPDATE_COOLDOWN" or event == "UPDATE_INVENTORY_ALERTS" ) then
      if ( this:IsVisible() ) then
         AIOIFrame_Update(AIOIFrame);
      end
   elseif (event == "MERCHANT_SHOW" or event == "AUCTION_HOUSE_SHOW" or event == "MAIL_SHOW" or event == "TRADE_SHOW" or event == "BANKFRAME_OPENED") then
      if (AIOIReplaceBags == 1) then
         OpenAIOIFrame();
      end;
   elseif (event == "MERCHANT_CLOSED" or event == "AUCTION_HOUSE_CLOSED" or event == "MAIL_CLOSED" or event == "TRADE_CLOSED" or event == "BANKFRAME_CLOSED") then
      if (AIOIReplaceBags == 1 and AIOIFreeze == 0) then
         CloseAIOIFrame();
      end;
   end
end

function AIOIFrame_OnHide()
   PlaySound("igBackPackClose");
   AIOI_UpdateBagState();
end

function AIOIFrame_OnShow()
   if AIOI_Initialized == false then
      AIOIFrame:Hide();
      return;
   end
   AIOIFrame_Update(AIOIFrame);
   PlaySound("igBackPackOpen");
   AIOIFrame:ClearAllPoints();
   AIOIFrame:SetPoint("BOTTOMRIGHT", "AIOIAnchorFrame", "BOTTOMRIGHT");
   local pScale = AIOIFrame:GetParent():GetScale();
   if ( not pScale ) then pScale = 1; end
   if AIOIFrame:GetScale() ~= pScale * tonumber(AIOIScale) then
      AIOIFrame:SetScale(AIOIScale);
   end
end

-- }}}
